#include <string.h>



typedef int Convertor(void * stream, float depthX, float depthY, float depthZ, float * worldX, float * worldY, float * worldZ);



int map_to_coord(int width, int height, unsigned short * input, float * output, void * stream, void * apply)
{
 int ret = 0;
 int y,x;
 
 Convertor * func = (Convertor*)apply;
 
 for (y=0; y<height; y++)
 {
  for (x=0; x<width; x++)
  {
   unsigned short in = input[y*width+x];
   float * out = output + (y*width + x) * 3;
   
   if (in!=0)
   {
    ret |= func(stream, x, y, in, out, out+1, out+2);
    
    out[0] /= 1000.0;
    out[1] /= 1000.0;
    out[2] /= 1000.0;
   }
   else
   {
    out[0] = 0.0;
    out[1] = 0.0;
    out[2] = -1.0;
   }
  }
 }
 
 return ret; 
}



int make_bobj(int width, int height, float * input, int * index, unsigned char * output, int rotate)
{
 unsigned char * start = output; 
 int x,y;
 
 // Count the number of valid vertices...
  float * targ = input;
  int vert_count = 0;
  for (y=0; y<height;y++)
  {
   for (x=0; x<width; x++)
   {
    if (targ[2]>0.0)
    {
     index[y*width + x] = vert_count;
     vert_count += 1;
    }
    targ += 3;
   }
  }
 
 // Vertex block...
  *(int*)output = vert_count;
  output += 4;
  
  targ = input;
  for (y=0; y<height;y++)
  {
   for (x=0; x<width; x++)
   {
    if (targ[2]>0.0)
    {
     if (rotate)
     {
      float out[3];
      out[0] = targ[0];
      out[1] = targ[2];
      out[2] = -targ[1];
      
      memcpy(output, out, 12);
      output += 12;
     }
     else
     {
      memcpy(output, targ, 12);
      output += 12;
     }
    }
   
    targ += 3;
   }
  }
  
 // Normal block...
  *(int*)output = vert_count;
  output += 4;
  
  targ = input;
  for (y=0; y<height;y++)
  {
   for (x=0; x<width; x++)
   {
    if (targ[2]>0.0)
    {
     if (rotate)
     {
      ((float*)output)[0] = 0.0;
      ((float*)output)[1] = -1.0;
      ((float*)output)[2] = 0.0;
     }
     else
     {
      ((float*)output)[0] = 0.0;
      ((float*)output)[1] = 0.0;
      ((float*)output)[2] = -1.0;
     }
    
     output += 12;
    }
   
    targ += 3;
   }
  }
  
 // Count the number of valid faces...
  int face_count = 0;
  for (y=1; y<height;y++)
  {
   for (x=1; x<width; x++)
   {
    int valid = 0;
    
    if (input[((y-1)*width + (x-1))*3 + 2]>0.0) valid += 1;
    if (input[((y-1)*width + x    )*3 + 2]>0.0) valid += 1;
    if (input[(    y*width + (x-1))*3 + 2]>0.0) valid += 1;
    if (input[(    y*width + x    )*3 + 2]>0.0) valid += 1;
    
    if (valid>2) face_count += valid-2;
   }
  }
  
 // Face block...
  *(int*)output = face_count;
  output += 4;
  
  for (y=1; y<height;y++)
  {
   for (x=1; x<width; x++)
   {
    int valid = 0;
    int ind[4];
    
    if (input[((y-1)*width + (x-1))*3 + 2]>0.0)
    {
     ind[valid] = index[(y-1)*width + (x-1)];
     valid += 1;
    }
    if (input[((y-1)*width + x)*3 + 2]>0.0)
    {
     ind[valid] = index[(y-1)*width + x];
     valid += 1;
    }
    if (input[(y*width + (x-1))*3 + 2]>0.0)
    {
     ind[valid] = index[y*width + (x-1)];
     valid += 1;
    }
    if (input[(y*width + x)*3 + 2]>0.0)
    {
     ind[valid] = index[y*width + x];
     valid += 1;
    }
    
    if (valid>=3)
    {
     memcpy(output, ind, 12);
     output += 12; 
    }
    
    if (valid==4)
    {
     memcpy(output, ind+1, 12);
     output += 12;
    }
   }
  }
  
 return output - start;
}
